/*
    Robot server - 2005 Jason Hunt
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: huntjas2@msu.edu
*/

#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#include "failsafe.h"
#include "controller.h"

int failsafe_running = 0;
int update_count = 0;

/* reset controller if the connection fails */
void *failsafe(void *id)
{
    failsafe_running = 1;

    printf("[Failsafe] Started\n");
    
    while(!program_done)
    {
        usleep(30000000);

        if (connected)
        {          
            if (update_count > 0)
            {
                update_count = 0;
            }
            else
            {
                printf("[Failsafe] No update, reset\n");
                reset_controller();
               
                connected = 0;
            }
        }
    }
    
    printf("[Failsafe] Shutdown\n");    
    
    pthread_exit(NULL); // exit thread
}
/* end of failsafe */
